// JavaScript Document

var myScroll;
var nearMeScroll;
var findNearMeScroll;
var promotionPageScroll;
var map;
var marker;
var spinner;
var page = 1;
var minPage = 1;
var maxPage = 4;
var isLoading = false;
var myLatitude = 0;
var myLongitude = 0;
// Default = parque de la 93
var defaultLatitude = 4.676777;
var defaultLongitude = -74.048275;
var gpsPos;
var stringPosNoGPS = "No es tu ubicación";
var pageNotLoaded = "La información no ha podido ser cargada. Es posible que no tengas acceso a Internet. Por favor intenta nuevamente.";
var gpsNotLoaded = "Tu ubicación no ha podido ser encontrada. Es posible que no tengas un GPS habilitado. Se cargará una ubicación por defecto que podrás cambiar.";
var watchID;
var xhr;
var opts = {
	lines: 7, // The number of lines to draw
	length: 1, // The length of each line
	width: 8, // The line thickness
	radius: 15, // The radius of the inner circle
	corners: 1, // Corner roundness (0..1)
	rotate: 0, // The rotation offset
	color: '#FFF', // #rgb or #rrggbb
	speed: 0.8, // Rounds per second
	trail: 77, // Afterglow percentage
	shadow: false, // Whether to render a shadow
	hwaccel: false, // Whether to use hardware acceleration
	className: 'spinner', // The CSS class to assign to the spinner
	zIndex: 2e9, // The z-index (defaults to 2000000000)
	top: 0, // Top position relative to parent in px
	left: 'auto' // Left position relative to parent in px
};

/* HIGHLIGHTS */

function loadHighlights(){
	if(myLatitude != 0 && myLongitude != 0){
		miPosHighlights(0);
	}else{
		$(document).ready(function(){
			navigator.geolocation.getCurrentPosition(miPosHighlights, errorMiPosHighlights, {enableHighAccuracy:true});
		});	
	}
}

function miPosHighlights(ubicacion){
	
		var output = $('#content-1');
		var output2 = $('#main-list');
		var output3 = $('#secondary-list');
		var output4 = $('#most-seen');
		$("#no-gps-container").html("");
		document.getElementById("most-seen-title").innerHTML = "";
		var lat = 0;
		var lon = 0;
		if(myLatitude != 0 && myLongitude != 0){
			lat = myLatitude;
			lon = myLongitude;
			$("#no-gps-container").append("<div class='no-gps' id='no-gps-highlights'>" + stringPosNoGPS + "</div>");
			$("#no-gps-highlights").swipe( {
				click:function(event, target){
					opciones();
				},
				threshold:50
			});
		}else{
			lat = ubicacion.coords.latitude;
			lon = ubicacion.coords.longitude;
		}
		/*if(xhr != null){
            xhr.abort();
			xhr = null;
        }*/
		xhr = $.ajax({
			cache: false,
			url: 'http://www.vencolombia.com/php/createHighlights.php',
			dataType: 'jsonp',
			jsonp: 'jsoncallback',
			data: 'latitude=' + lat + '&longitude=' + lon,
			timeout: 5000,
			
			// SUCCESS
			success: function(data, status){
				
				// RESET CONTENT
				$("#no-gps-container").html("");
				if(myLatitude != 0 && myLongitude != 0){
					$("#no-gps-container").append("<div class='no-gps' id='no-gps-highlights'>" + stringPosNoGPS + "</div>");
					$("#no-gps-highlights").swipe( {
						click:function(event, target){
							opciones();
						},
						threshold:50
					});
				}
				document.getElementById("most-seen-title").innerHTML = "";
				output2.html("");
				output3.html("");
				output4.html("");
				
				// VARS FOR FINAL DIMENSIONS
				var finalMainDimensions = "";
				var finalSecondaryDimensions = "";
				var finalMostSeenDimensions = "";
				var secondaryQuantity = 0;
				var mostSeenQuantity = 0;
				
				// GO THROUGH ARRAY
				$.each(data, function(i,item){ 
				
					// HIGHLIGHTS ARRAY
					if(item.discount_id != null){
						
						// MAIN 1
						if(item.importance == 1){
							var landmark = "<li class='slider-item'><div id='main-highlight-" + item.id + "'><div class='main-highlight-text'>" + item.text + "</div><img id='main-discount-" + item.id + "' src='http://www.vencolombia.com/images/discounts/" + item.discount_id + ".jpg' width='600' height='300' alt='Imagen destacada " + item.id + "' /></div></li>";
							output2.append(landmark);
							finalMainDimensions = setImageWidthSize(0.9, '#main-discount-' + item.id, 600);
							$("#main-highlight-" + item.id).swipe( {
								click:function(event, target){
									if(item.search != ""){
										document.getElementById("keywords").value = item.search;
										buscar(0);
									}else{
										goToPromotionPage(item.discount_id);
									}
								},
								threshold:50
							});
							
						// MAIN 2
						}else if(item.importance == 2){
							var landmark = "<div id='secondary-highlight-" + item.id + "' class='secondary-highlight'><div class='secondary-highlight-text'>" + item.text + "</div><img id='secondary-discount-" + item.id + "' src='http://www.vencolombia.com/images/discounts/" + item.discount_id + "_square.jpg' width='190' height='190' alt='Imagen secundaria destacada " + item.id + "' /></div>";
							secondaryQuantity ++;
							output3.append(landmark);
							finalSecondaryDimensions = setImageWidthSize(0.28, '#secondary-discount-' + item.id, 190);
							$("#secondary-highlight-" + item.id).swipe( {
								click:function(event, target){
									if(item.search != ""){
										document.getElementById("keywords").value = item.search;
										buscar(0);
									}else{
										goToPromotionPage(item.discount_id);
									}
								},
								threshold:50
							});
						}
						
					// DISCOUNTS ARRAY
					}else if(item.latitude != null){
						
						// MOST SEEN
						if(item.seen > 0){
							document.getElementById("most-seen-title").innerHTML = "LOS MÁS VISTOS:";
							var landmark = "<div class='secondary-highlight' id='most-seen-" + item.id + "'><div class='secondary-highlight-text'>" + item.highlight_min + "</div><img id='most-seen-discount-" + item.id + "' src='http://www.vencolombia.com/images/discounts/" + item.id + "_square.jpg' width='190' height='190' alt='Imagen secundaria destacada " + item.id + "' /></div>";
							mostSeenQuantity ++;
							output4.append(landmark);
							finalMostSeenDimensions = setImageWidthSize(0.28, '#most-seen-discount-' + item.id, 190);
							$("#most-seen-" + item.id).swipe( {
								click:function(event, target){
									goToPromotionPage(item.id);
								},
								threshold:50
							});
						}
					}
				});
				
				// set dimensions for main highlights in rotator
				var finalWidth = finalMainDimensions.split("/")[0] + "px";
				var finalHeight = (parseInt(finalMainDimensions.split("/")[1]) + 35) + "px";
				document.getElementById("slider").style.width = finalWidth;
				$('.slider-item').width(finalWidth);
				document.getElementById("slider").style.height = finalHeight;
				$('.slider-item').height(finalHeight);
				// SET IMAGE SLIDER
				$(output2).cycle({fx: 'fade', timeout: 6000});
				
				// SECONDARY HIGHLIGHTS
				document.getElementById("secondary-list").style.width = finalWidth;
				document.getElementById("secondary-list").style.height = "" + (parseInt(finalSecondaryDimensions.split('/')[1]) + 35) * (Math.ceil(secondaryQuantity / 3)) + "px";
				
				// MOST SEEN TITLE AND DIMENSIONS
				document.getElementById("most-seen-title").style.width = finalWidth;
				document.getElementById("most-seen").style.width = finalWidth;
				document.getElementById("most-seen").style.height = "" + (parseInt(finalMostSeenDimensions.split('/')[1]) + 35) * (Math.ceil(mostSeenQuantity / 3)) + "px";
				
				// SCROLL
				myScroll.refresh();
				quitLoading();
			},
			
			// ERROR
			error: function(){
				navigator.notification.alert(pageNotLoaded, highlightNotLoadedAccepted, "Cargar nuevamente", "Recargar");
				myScroll.refresh();
				quitLoading();
			}
		});
	
}

function errorMiPosHighlights(ubicacion){
	myScroll.refresh();
	quitLoading();
	navigator.notification.alert(gpsNotLoaded, gpsNotLoadedAccepted, "Ubicación", "Ver ubicación");
}

function gpsNotLoadedAccepted(){
	opciones();
}

function highlightNotLoadedAccepted(){
	destacados();
}

function destacados(){
	var output2 = $('#main-list');
	output2.html("");
	var output3 = $('#secondary-list');
	output3.html("");
	var output4 = $('#most-seen');
	output4.html("");
	document.getElementById("most-seen-title").innerHTML = "";
	document.getElementById("no-gps-container").innerHTML = "";
	document.getElementById("container").style.left = "-100%";
	if(!isLoading || page != 1){
		loadHighlights();
		setLoading();
	}
	page = 1;
	afterPageChanged();
	
}

/* NEAR ME */

var nearMeLoadNumber = 0;
var uniqueIDS = new Array();

function cerca(loadNumber){
	nearMeLoadNumber = loadNumber;
	if(nearMeLoadNumber != 0){
		$("#more-div-" + nearMeLoadNumber).html("");
	}
	if(!isLoading || page != 2){
		if(myLatitude != 0 && myLongitude != 0){
			miPosCercaDeMi(0);
		}else{
			navigator.geolocation.getCurrentPosition(miPosCercaDeMi, errorMiPosCercaDeMi, {enableHighAccuracy:true});
		}
	}
	page = 2;
	if(nearMeLoadNumber == 0){
		document.getElementById("content-2").innerHTML = "";
		afterPageChanged();
	}
	setLoading();
	document.getElementById("container").style.left = "-200%";
}

function miPosCercaDeMi(ubicacion){
	if(nearMeLoadNumber == 0){
		var output = $('#content-2');
		uniqueIDS = new Array();
	}else{
		var output = $('#more-div-' + nearMeLoadNumber);
		output.html("");
	}
	var lat = 0;
	var lon = 0;
			
	if(myLatitude != 0 && myLongitude != 0){
		lat = myLatitude;
		lon = myLongitude;
	}else{
		lat = ubicacion.coords.latitude;
		lon = ubicacion.coords.longitude;
	}
	/*if(xhr != null){
        xhr.abort();
		xhr = null;
    }*/
	xhr = $.ajax({
		cache: false,
		url: 'http://www.vencolombia.com/php/nearMe.php',
		dataType: 'jsonp',
		jsonp: 'jsoncallback',
		data: 'latitude=' + lat + '&longitude=' + lon + "&from=" + nearMeLoadNumber,
		timeout: 5000,
		
		// SUCCESS
		success: function(data, status){
			
			// RESET CONTENT
			output.html("");
			
			// vars
			var finalImageDimensions = "";
			
			// UPDATE BUTTON
			if(nearMeLoadNumber == 0){
				if(myLatitude != 0 && myLongitude != 0){
					output.append("<div class='no-gps' id='no-gps-near'>" + stringPosNoGPS + "</div>");	
					$("#no-gps-near").swipe( {
						click:function(event, target){
							opciones();
						},
						threshold:50
					});
				}
				output.append("<div id='update-near'>ACTUALIZAR POSICIÓN</div>");
				$("#update-near").swipe( {
					click:function(event, target){
						myLongitude = 0;
						myLatitude = 0;
						cerca(0);
					},
					threshold:50
				});
			}
			
			// LOOP
			$.each(data, function(i,item){
				
				if(item.id != null){
					
					// Ensures Unique id
					if(uniqueIDS.indexOf(item.id) == -1){
						var landmark = "<div class='near-me' id='near-me-" + item.id + "'><div class='near-distance'><img id='pointer-" + item.id + "' src='images/pointer.png' alt='pointer' width='24' height='24' /><p>" + (distance(lat, lon, item.latitude, item.longitude, "K")).toFixed(1) + "km</p></div><div class='near-distance-description-separator'></div><div class='near-description'>" + item.highlight + "</div><img class='near-image' id='near-image-" + item.id + "' src='http://www.vencolombia.com/images/discounts/" + item.id + "_square.jpg' width='190' height='190' alt='Cerca de mi " + item.id + "' /></div><div class='clear'></div><div class='near-separator'></div>";
						output.append(landmark);
						finalImageDimensions = setImageWidthSize(0.28, '#near-image-' + item.id, 190);
						setImageWidthSize(0.06, '#pointer-' + item.id, 24);
						$('#pointer-' + item.id).height($('#pointer-' + item.id).width());
						$("#near-me-" + item.id).swipe( {
							click:function(event, target){
								goToPromotionPage(item.id);
							},
							threshold:50
						});
						uniqueIDS.push(item.id);
					}
				}
				
				// MORE BUTTON
				if(item.morebutton == 1){
					var nextNumber = nearMeLoadNumber + 1;
					output.append("<div class='more-div' id='more-div-" + nextNumber + "'><div id='load-more-" + nextNumber + "' class='load-more'>CARGAR MÁS</div></div>");
					$("#load-more-" + nextNumber + "").swipe( {
						click:function(event, target){
							// load more
							cerca(nearMeLoadNumber + 1);
						},
						threshold:50
					});
				}
			});
			
			// set dimensions for image
			var finalHeight = (parseInt(finalImageDimensions.split("/")[1])) + "px";
			$('.near-me').height(finalHeight);
			// set description and distance width
			var finalTextsDivWidth = (($('.near-me').width() - parseInt(finalImageDimensions.split("/")[0])) - ($('.near-me').width() * 0.015)) + "px";
			$('.near-distance').width(finalTextsDivWidth);
			$('.near-distance-description-separator').width(finalTextsDivWidth);
			$('.near-description').width(finalTextsDivWidth);
			
			// SCROLL
			nearMeScroll.refresh();
			quitLoading();
		},
		
		// ERROR
		error: function(){
			navigator.notification.alert(pageNotLoaded, nearMeNotLoadedAccepted, "Cargar nuevamente", "Recargar");
			nearMeScroll.refresh();
			quitLoading();
		}
	});
}

function nearMeNotLoadedAccepted(){
	cerca(nearMeLoadNumber);
}

function errorMiPosCercaDeMi(){
	nearMeScroll.refresh();
	quitLoading();
	navigator.notification.alert(gpsNotLoaded, gpsNotLoadedAccepted, "Ubicación", "Ver ubicación");
}

/* SEARCH */

var searchNearMeLoadNumber = 0;

function buscar(number){
	searchNearMeLoadNumber = number;
	document.getElementById("container").style.left = "-300%";
	if(searchNearMeLoadNumber != 0){
		$("#search-more-div-" + searchNearMeLoadNumber).html("");
	}
	if(!isLoading || page != 3){
		if(document.getElementById("keywords").value != "Buscar..."){
			if(myLatitude != 0 && myLongitude != 0){
				miPosBuscarCercaDeMi(0);
			}else{
				navigator.geolocation.getCurrentPosition(miPosBuscarCercaDeMi, errorBuscarMiPosCercaDeMi, {enableHighAccuracy:true});
			}
		}
	}
	page = 3;
	if(searchNearMeLoadNumber == 0){
		document.getElementById("content-3").innerHTML = "";
		afterPageChanged();
	}
	if(document.getElementById("keywords").value != "Buscar..."){
		setLoading();
	}
}

function miPosBuscarCercaDeMi(ubicacion){
	if(searchNearMeLoadNumber == 0){
		var output = $('#content-3');
		output.html("");
		uniqueIDS = new Array();
	}else{
		var output = $('#search-more-div-' + searchNearMeLoadNumber);
		output.html("");
	}
	var lat = 0;
	var lon = 0;
	if(myLatitude != 0 && myLongitude != 0){
		lat = myLatitude;
		lon = myLongitude;
	}else{
		lat = ubicacion.coords.latitude;
		lon = ubicacion.coords.longitude;
	}
	/*if(xhr != null){
    	xhr.abort();
		xhr = null;
    }*/
	
	xhr = $.ajax({
		cache: false,
		url: 'http://www.vencolombia.com/php/findNearMe.php',
		dataType: 'jsonp',
		jsonp: 'jsoncallback',
		data: 'latitude=' + lat + '&longitude=' + lon + "&from=" + searchNearMeLoadNumber + "&keywords=" + document.getElementById("keywords").value,
		timeout: 5000,
		success: function(data, status){
			
			// RESET CONTENT
			output.html("");
			
			if(searchNearMeLoadNumber == 0){
				if(myLatitude != 0 && myLongitude != 0){
					output.append("<div class='no-gps' id='no-gps-search'>" + stringPosNoGPS + "</div>");	
					$("#no-gps-search").swipe( {
						click:function(event, target){
							opciones();
						},
						threshold:50
					});
				}
			}
			
			var finalImageDimensions = "";
			
			$.each(data, function(i,item){ 
				if(item.id != null){
					
					// Ensures Unique id
					if(uniqueIDS.indexOf(item.id) == -1){
						var landmark = "<div class='near-me' id='near-me-" + item.id + "'><div class='near-distance'><img id='pointer-" + item.id + "' src='images/pointer.png' alt='pointer' width='24' height='24' /><p>" + (distance(lat, lon, item.latitude, item.longitude, "K")).toFixed(1) + "km</p></div><div class='near-distance-description-separator'></div><div class='near-description'>" + item.highlight + "</div><img class='near-image' id='near-image-" + item.id + "' src='http://www.vencolombia.com/images/discounts/" + item.id + "_square.jpg' width='190' height='190' alt='Cerca de mi " + item.id + "' /></div><div class='clear'></div><div class='near-separator'></div>";
						output.append(landmark);
						finalImageDimensions = setImageWidthSize(0.28, '#near-image-' + item.id, 190);
						setImageWidthSize(0.06, '#pointer-' + item.id, 24);
						$('#pointer-' + item.id).height($('#pointer-' + item.id).width());
						$("#near-me-" + item.id).swipe( {
							click:function(event, target){
								goToPromotionPage(item.id);
							},
							threshold:50
						});
						uniqueIDS.push(item.id);
					}
				}
				
				// MORE BUTTON
				if(item.morebutton == 1){
					var nextNumber = searchNearMeLoadNumber + 1;
					output.append("<div class='more-div' id='search-more-div-" + nextNumber + "'><div id='search-load-more-" + nextNumber + "' class='load-more'>CARGAR MÁS</div></div>");
					$("#search-load-more-" + nextNumber + "").swipe( {
						click:function(event, target){
							// load more
							buscar(nextNumber);
						},
						threshold:50
					});
				}
				if(item.nothing == 1){
					output.text('No hemos encontrado ningún resultado.');
				}
			});
			
			// set dimensions for image
			var finalHeight = (parseInt(finalImageDimensions.split("/")[1])) + "px";
			$('.near-me').height(finalHeight);
			// set description and distance width
			var finalTextsDivWidth = (($('.near-me').width() - parseInt(finalImageDimensions.split("/")[0])) - ($('.near-me').width() * 0.015)) + "px";
			$('.near-distance').width(finalTextsDivWidth);
			$('.near-distance-description-separator').width(finalTextsDivWidth);
			$('.near-description').width(finalTextsDivWidth);
			
			findNearMeScroll.refresh();
			quitLoading();
		},
		error: function(){
			navigator.notification.alert(pageNotLoaded, searchNotLoadedAccepted, "Cargar nuevamente", "Recargar");
			findNearMeScroll.refresh();
			quitLoading();
		}
	});	
}

function searchNotLoadedAccepted(){
	buscar(searchNearMeLoadNumber);
}

function errorBuscarMiPosCercaDeMi(){
	findNearMeScroll.refresh();
	quitLoading();
	navigator.notification.alert(gpsNotLoaded, gpsNotLoadedAccepted, "Ubicación", "Ver ubicación");
}

function keywordsFocus(){
	if(document.getElementById('keywords').value == 'Buscar...'){
		document.getElementById('keywords').value = '';	
	}
}

function searchKeyPress(e){
	if(e.keyCode == 13){
		searchNearMeLoadNumber = 0;
		buscar(0);
	}
}

/* OPTIONS */

function opciones(){
	page = 4;
	afterPageChanged();
	document.getElementById("container").style.left = "-400%";
	 // TESTING GOOGLE MAPS
	var output = $('#content-4');
	if(map == null){
		setLoading();
		output.append("<div id='map_canvas' class='noSwipe' style='height:" + (window.innerHeight * 0.4) + "px;'></div>");
	}
	googleMaps();
}

function googleMaps() {
	// watchID = navigator.geolocation.watchPosition(posicionCargada, errorAlCargarPosicion, { frequency: 3000,  enableHighAccuracy:true});
	navigator.geolocation.getCurrentPosition(posicionCargada, errorAlCargarPosicion, {enableHighAccuracy:true});
}

function posicionCargada(ubicacion){
	var lat = 0;
	var lon = 0;
	if(myLatitude != 0 && myLongitude != 0){
		lat = myLatitude;
		lon = myLongitude;
	}else{
		lat = ubicacion.coords.latitude;
		lon = ubicacion.coords.longitude;
	}
	createOptions(lat, lon);
}

function errorAlCargarPosicion(){
	myLatitude = defaultLatitude;
	myLongitude = defaultLongitude;
	createOptions(myLatitude, myLongitude);
}

function createOptions(latitude, longitude){
	var latlng = new google.maps.LatLng(latitude, longitude);
	if(map == null){
		var myOptions = {
			zoom: 14,
			center: latlng,
			draggable:true,
			mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
		marker = new google.maps.Marker({
			position: latlng,
			map: map
		});
		google.maps.event.addListener(map, 'click', function(event) {
			gpsPos = event.latLng;
			navigator.notification.confirm("¿Deseas usar esta ubicación como punto de referencia para los resultados?", confirmarCambioDePos, "Cambiar posición", "Si,Cancelar");
		});
		$('#content-4').append("<div id='actual-pos' class='load-more'>Obtener posición actual</div>");
		$("#actual-pos").swipe( {
			click:function(event, target){
				myLatitude = 0;
				myLongitude = 0;
				googleMaps();
			},
			threshold:50
		});
		$('#options-title').text("MI UBICACIÓN:");
		$('#content-4').append("<p class='mail'>contacto@vencolombia.com</p>");
		quitLoading();
	}else{
		marker.setPosition(latlng);
		map.setCenter(latlng);
	}
}

function confirmarCambioDePos(id){
	if(id == 1){
		var myLatLng = gpsPos;
		myLatitude = myLatLng.lat();
		myLongitude = myLatLng.lng();
		marker.setPosition(myLatLng);
	}
}

/* PROMOTION PAGE */

var promotionID = 0;

function goToPromotionPage(id){
	promotionID = id;
	page = 5;
	afterPageChanged();
	document.getElementById("container").style.left = "-500%";
	setLoading();
	
	var output = $('#content-5');
	output.html("");
	promotionPageScroll.refresh();
	
	if(myLatitude == 0 && myLongitude == 0){
		navigator.geolocation.getCurrentPosition(getPromotionPage, errorPositionPromotionPage, {enableHighAccuracy:true});
	}else{
		getPromotionPage(0);
	}
	
}

function getPromotionPage(ubicacion){
	var lat = 0;
	var lon = 0;
	if(myLatitude != 0 && myLongitude != 0){
		lat = myLatitude;
		lon = myLongitude;
	}else{
		lat = ubicacion.coords.latitude;
		lon = ubicacion.coords.longitude;
	}
	var output = $('#content-5');
	/*if(xhr != null){
    	xhr.abort();
		xhr = null;
    }*/
	xhr = $.ajax({
		cache: false,
		url: 'http://www.vencolombia.com/php/promotionPage.php',
		dataType: 'jsonp',
		jsonp: 'jsoncallback',
		data: 'id=' + promotionID,
		timeout: 5000,
		success: function(data, status){
			
			// RESET CONTENT
			output.html("");
			
			// VARS
			var mapLatitude = 0;
			var mapLongitude = 0;
			var finalPromDimensions = "";
			
			if(myLatitude != 0 && myLongitude != 0){
				output.append("<div class='no-gps' id='no-gps-promotion'>" + stringPosNoGPS + "</div>");
				$("#no-gps-promotion").swipe( {
					click:function(event, target){
						opciones();
					},
					threshold:50
				});
			}
			
			$.each(data, function(i,item){ 
				if(item.id != null){
					if(item.start_time != 0){
						var startDate = new Date(item.start_time * 1000);
						var startFormatedDate = startDate.getDate() + "/" + (startDate.getMonth() + 1) + "/" + startDate.getFullYear();
					}else{
						var startFormatedDate = "Sin fecha inicio";
					}
					if(item.end_time != 9999999999){
						var endDate = new Date(item.end_time * 1000);
						var endFormatedDate = endDate.getDate() + "/" + (endDate.getMonth() + 1) + "/" + endDate.getFullYear();
					}else{
						var endFormatedDate = "Sin fecha final";
					}
					var landmark = "<div id='promotion-page'><h1>" + item.highlight + "</h1><img class='promotion-page-image' id='discount-page-image' src='http://www.vencolombia.com/images/discounts/" + item.id + ".jpg' width='600' height='300' /><div class='start-date'>Inicio: " + startFormatedDate + "</div><div class='end-date'>Final: " + endFormatedDate + "</div><div class='clear'></div><div class='date-extra'>" + item.date_extra + "</div><div class='promotion-distance promotion-details'><img src='images/pointer.png' />" + (distance(lat, lon, item.latitude, item.longitude, 'K')).toFixed(1) + "km</div><div class='promotion-value promotion-details'><img src='images/highlight.png' />" + item.value + "</div><div class='promotion-phone promotion-details'><img src='images/phone.png' />" + item.phone + "</div><div class='promotion-address promotion-details'><img src='images/pointer.png' />" + item.address + "</div><div class='clear'></div><div id='promotion-map' style='width:100%; height:" + (window.innerHeight * 0.4) + "px; margin:1% 0 2% 0;'></div><p class='promotion-p'>" + item.text + "</p></div>";
					output.append(landmark);
					finalPromDimensions = setImageWidthSize(0.9, '#discount-page-image', 600);
					mapLatitude = item.latitude;
					mapLongitude = item.longitude;
				}
			});
			
			// dimensions
			var finalWidth = finalPromDimensions.split("/")[0] + "px";
			document.getElementById("promotion-page").style.width = finalWidth;
			
			// MAP
			var latlng = new google.maps.LatLng(mapLatitude, mapLongitude);
			var myOptions = {
				zoom: 14,
				center: latlng,
				draggable: false,
				panControl: true,
				zoomControl: true,
				zoomControlOptions: {
					style: google.maps.ZoomControlStyle.SMALL
				},
				mapTypeId: google.maps.MapTypeId.ROADMAP
			};
			var promotionMap = new google.maps.Map(document.getElementById("promotion-map"), myOptions);
			var promotionMarker = new google.maps.Marker({
				position: latlng,
				map: promotionMap
			});
			
			// 
			promotionPageScroll.refresh();
			quitLoading();
		},
		error: function(){
			navigator.notification.alert(pageNotLoaded, promotionNotLoadedAccepted, "Cargar nuevamente", "Recargar");
			promotionPageScroll.refresh();
			quitLoading();
		}
	});	
}

function promotionNotLoadedAccepted(){
	goToPromotionPage(promotionID);
}

function errorPositionPromotionPage(){
	promotionPageScroll.refresh();
	quitLoading();
	navigator.notification.alert(gpsNotLoaded, gpsNotLoadedAccepted, "Ubicación", "Ver ubicación");
}

/* UTILITIES */

function distance(lat1, lon1, lat2, lon2, unit) {
	var radlat1 = Math.PI * lat1/180;
	var radlat2 = Math.PI * lat2/180;
	var radlon1 = Math.PI * lon1/180;
	var radlon2 = Math.PI * lon2/180;
	var theta = lon1-lon2;
	var radtheta = Math.PI * theta/180;
	var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
	dist = Math.acos(dist);
	dist = dist * 180/Math.PI;
	dist = dist * 60 * 1.1515;
	if (unit=="K") {
		 dist = dist * 1.609344 
	}
	if (unit=="N") { 
		dist = dist * 0.8684 
	}
	return dist;
}

function setImageHeightSize(percent, id){
	$(id).height(window.innerHeight * percent);
	$(window).resize(function(){$(id).height(window.innerHeight * percent);});
}

function setImageWidthSize(percent, id, maxWidth){
	if(window.innerWidth * percent < maxWidth){
		var oldWidth = $(id).width();
		$(id).width(window.innerWidth * percent);
		var newWidth = window.innerWidth * percent;
		var changePercent = newWidth / oldWidth;
		$(id).height($(id).height() * changePercent);
	}
	return $(id).width() + "/" + $(id).height();
}

function setButtons(){
	document.getElementById("button-1").setAttribute("class", "button");
	document.getElementById("button-2").setAttribute("class", "button");
	document.getElementById("button-3").setAttribute("class", "button");
	document.getElementById("button-4").setAttribute("class", "button");
	if(page > 0 && page < 5){
		document.getElementById("button-" + page).setAttribute("class", "button active");
	}
}

function setLoading(){
	if(isLoading == false){
		isLoading = true;
		$('#loading').show();
		spinner = new Spinner(opts).spin(document.getElementById('loading'));
	}
}

function quitLoading(){
	if(spinner != null){
		spinner.stop();
	}
	spinner = null;
	$('#loading').hide();
	isLoading = false;
}

function myDeviceReady(){
	loadHighlights();
	navigator.splashscreen.hide();
}

function init(){
	document.addEventListener("deviceready", myDeviceReady, false);
}

function setMovement(){
	$(this).swipe({
		swipe:function(event, direction, distance, duration, fingerCount) {
			if(direction == 'right'){
				if(page > minPage){
					quitLoading();
					$('#container').animate({
						left: '+=100%',
					}, 300, function() {
						// Animation complete.
						page --;
						afterPageChanged();
						if(page == 1){
							destacados();
						}else if(page == 2){
							cerca(0);
						}else if(page == 3){
							buscar(0);
						}else if(page == 4){
							opciones();
						}
					});
					
				}
			}else if(direction == 'left'){
				if(page < maxPage){
					quitLoading();
					$('#container').animate({
						left: '-=100%',
					}, 300, function() {
						// Animation complete.
						page ++;
						afterPageChanged();
						if(page == 1){
							destacados();
						}else if(page == 2){
							cerca(0);
						}else if(page == 3){
							buscar(0);
						}else if(page == 4){
							opciones();
						}
					});
					
				}
			}else{
				
			}
		 },
		threshold:30,
		excludedElements:$.fn.swipe.defaults.excludedElements,
	});
}

function afterPageChanged(){
	$("#keywords").blur();
	setButtons();
	if(page != 1){
		var output2 = $('#main-list');
		output2.html("");
		var output3 = $('#secondary-list');
		output3.html("");
		var output4 = $('#most-seen');
		output4.html("");
		document.getElementById("most-seen-title").innerHTML = "";
	}
	if(page != 2){
		var output = $('#content-2');
		output.html("");
	}
	if(page != 3){
		var output = $('#content-3');
		output.html("");
	}
}